VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsSystem3"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Copyright (C) 2003  Jrgen Niesner, Stefan Rhrl
'This program is free software; you can redistribute it and/or modify it under the terms of the
'GNU General Public License as published by the Free Software Foundation; either version 2 of the
'License, or (at your option) any later version.

'This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
'even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License along with this program; if not,
'write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
'
'Auf Deutsch (ohen Garantie fr die bersetzung)
'Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der GNU General Public License,
'wie von der Free Software Foundation verffentlicht, weitergeben und/oder modifizieren, entweder gem
'Version 2 der Lizenz oder (nach Ihrer Option) jeder spteren Version.

'Die Verffentlichung dieses Programms erfolgt in der Hoffnung, da es Ihnen von Nutzen sein wird, aber
'OHNE IRGENDEINE GARANTIE, sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT FR
'EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License.

'Sie sollten eine Kopie der GNU General Public License zusammen mit diesem Programm erhalten haben. Falls
'nicht, schreiben Sie an die Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.

'=========================
'---------------------------------------------------------------------------------------
' Module    : clsSystem3
' DateTime  : 21.11.2003 10:04
' Author    : Niesner
' Purpose   : stellt verschiedene Methoden zum Thema Systemprozesse bereit
' Info      : Die Klasse war zum Zeitpunkt er Kommentierung schon teilweise vorhanden
'           : und im Einsatz, die Kommentierung wurde bei den alten Codeteilen nicht ergnzt
' ChangeLog : warteAufProzess und notwendige Sub-Methoden eingefgt (21.11.2003 10:06, Niesner)
'---------------------------------------------------------------------------------------
Option Explicit
Option Base 0

Private Declare Function GetUserName Lib "advapi32.dll" Alias "GetUserNameA" _
        (ByVal lpBuffer As String, nSize As Long) As Long
        
Private Declare Function CreateToolhelpSnapshot Lib "kernel32" _
        Alias "CreateToolhelp32Snapshot" (ByVal lFlags As Long, _
        ByVal lProcessID As Long) As Long
 
Private Declare Function ProcessFirst Lib "kernel32" Alias _
        "Process32First" (ByVal hSnapShot As Long, uProcess _
        As PROCESSENTRY32) As Long
 
Private Declare Function ProcessNext Lib "kernel32" Alias _
        "Process32Next" (ByVal hSnapShot As Long, uProcess _
        As PROCESSENTRY32) As Long
 
Private Declare Sub CloseHandle Lib "kernel32" (ByVal hPass _
        As Long)
 
Private Declare Function OpenProcess Lib "kernel32" (ByVal _
        dwDesiredAccess As Long, ByVal bInheritHandle As _
        Long, ByVal dwProcessId As Long) As Long

Private Declare Function TerminateProcess Lib "kernel32" (ByVal _
        hProcess As Long, ByVal uExitCode As Long) As Long
 
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
 
 
Const TH32CS_SNAPPROCESS As Long = 2&
Const MAX_PATH As Integer = 260
Const PROCESS_TERMINATE = &H1
Private sLogFilePfad As String
Private lLogFile As Long                       ' Nummer fr log file
Private bNolog As Boolean                   ' true: no log file write

 
Private Type PROCESSENTRY32
    dwSize As Long
    cntUsage As Long
    th32ProcessID As Long
    th32DefaultHeapID As Long
    th32ModuleID As Long
    cntThreads As Long
    th32ParentProcessID As Long
    pcPriClassBase As Long
    dwFlags As Long
    szExeFile As String * MAX_PATH
End Type

Private Sub Class_Initialize()
'
End Sub

Private Sub Class_Terminate()
'
'
End Sub
    
' Diese Funktion liefert den Benutzernamen zurck
Public Function ermittleUserName() As String
    Dim sPuffer As String
    Dim lPufferLaenge As Long
    
    lPufferLaenge = 255                                     ' Laenge des Puffers
    sPuffer = String$(lPufferLaenge, Chr$(0))               ' Puffer
    
    
    GetUserName sPuffer, lPufferLaenge
                                                            ' c-String umwandeln
    ermittleUserName = UCase$(Trim$(Left$(sPuffer, lPufferLaenge - 1)))
End Function

'---------------------------------------------------------------------------------------
' Procedure : warteAufProzess
' DateTime  : 22.04.2003 06:29
' Author    : Niesner
' Purpose   : starte Shell Befehl und wartet max. lMaxMinuten auf auf dessen Ende
' Info      :
' ChangeLog : killProzess ausgelagert (25.04.2003 09:15, Niesner)
' ChangeLog : Aus SAPKonvStarter.modmain kopiert und DebugLogs entfernt (21.11.2003 10:03, Niesner)
'---------------------------------------------------------------------------------------
Public Function warteAufProzess(ByVal sShellKommando As String, ByVal lMaxMinuten As Long, _
            ByRef ProzessNamen() As String) As Boolean
    Dim lProzessID As Long                                  'Wir merken uns die Nummer
'    Dim sProzessName As String                              'Name zur Nummer
    Dim dEndzeitpunkt As Double                             'Hier soll alles vorbei sein
    Dim bResult As Boolean                                  'frs Ergebnis
    Dim bSchleifenEnde As Boolean                           'als bedingung
    Call killProzesse(ProzessNamen)                         'normal darf es die Prozesse nicht geben, aber trotzdem zur Sicherheit raus damit
    lProzessID = Shell(sShellKommando)                      'Shell starten und ID merken
'    sProzessName = liefereProzessName(lProzessID)           'den mane zur ID suchen, wichtig, damit prozess auch gelscht wird, wenn er sich selbst duplizert
    dEndzeitpunkt = TimeStamp(lMaxMinuten * 60)             'Ende Berechnen
    Do                                                      'In Schleife
        Call Pause(10, True)                                'Nichts tun
        If ZeitUeberschreitung(dEndzeitpunkt) Then          'Bei einer Zeitberschreitung
            bSchleifenEnde = True                           'Raus aus der Schleife
            bResult = False                                 'und Fehler
        ElseIf ProzessBeendet2(lProzessID) Then             'Wenn alles fertig
            bSchleifenEnde = True                           'raus aus der Schleife
            bResult = True                                  'und OK
        Else
            bSchleifenEnde = False                          'sonst noch eine runde
        End If
    Loop Until bSchleifenEnde                               'haben wir ein ende
    Call killProzesse(ProzessNamen)                         'zur Sichehrit nochmal aufrumen
    warteAufProzess = bResult
End Function

'---------------------------------------------------------------------------------------
' Procedure : ProzessBeendet2
' DateTime  : 01.12.2003 12:31
' Author    : Niesner
' Purpose   : liefter True falls es die ProzessID nicht mehr gibt
' Info      : aus ProzessBeendet kopiert und fr ID umgebaut
'---------------------------------------------------------------------------------------
Private Function ProzessBeendet2(ByVal lProzessID As Long) As Boolean
    Dim bResult As Boolean                                  'frs Ergebnis
    If liefereProzessName(lProzessID) = "" Then             '""=Prozess gibt es nicht mehr
        bResult = True                                      'muss also schon beendet sein
    Else
        bResult = False                                     'ist noch nicht beendet
    End If
    ProzessBeendet2 = bResult                               'ergebnis zurck
End Function

'---------------------------------------------------------------------------------------
' Procedure : ProzessBeendet
' DateTime  : 25.04.2003 11:28
' Author    : Niesner
' Purpose   : prft ob der Prozess mit Name sProzessName bereits aus taskliste verschwunden ist
' Info      :
' ChangeLog : Aus SAPKonvStarter.modmain kopiert und DebugLogs entfernt (21.11.2003 10:03, Niesner)
'---------------------------------------------------------------------------------------
Private Function ProzessBeendet(ByVal sProzessName As String) As Boolean
    Dim bResult As Boolean                                  'frs Ergebnis
    If liefereProzessID(sProzessName) = 0 Then              '0=Prozess gibt es nicht mehr
        bResult = True                                      'muss also schon beendet sein
    Else
        bResult = False                                     'ist noch nicht beendet
    End If
    ProzessBeendet = bResult                                'ergebnis zurck
End Function


'---------------------------------------------------------------------------------------
' Procedure : ZeitUeberschreitung
' DateTime  : 25.04.2003 11:20
' Author    : Niesner
' Purpose   : vergelicht den momentanen Zeitpunkt mit dEndzeitpunkt
' Info      : bei Bedarf um Endzeitpunktverlngerung erweitern
' ChangeLog : Aus SAPKonvStarter.modmain kopiert und DebugLogs entfernt (21.11.2003 10:03, Niesner)
'---------------------------------------------------------------------------------------
Private Function ZeitUeberschreitung(ByRef dEndzeitpunkt As Double) As Boolean
    Dim bResult As Boolean                                  'frs Ergebnis
    If dEndzeitpunkt < TimeStamp() Then                     'sind wir schon bers Ende hinaus
        bResult = True                                      'Ja
    Else
        bResult = False                                     'Nein
    End If
    ZeitUeberschreitung = bResult                           'Ergebnis zurck
End Function

'---------------------------------------------------------------------------------------
' Procedure : killProzesse
' DateTime  : 25.04.2003 07:23
' Author    : Niesner
' Purpose   : versucht alle Prozesse aus dem ProzessNamen-Feld per API-Kill zu lschen
' Info      :
' ChangeLog : Aus SAPKonvStarter.modmain kopiert und DebugLogs entfernt (21.11.2003 10:03, Niesner)
'---------------------------------------------------------------------------------------
Private Sub killProzesse(ByRef ProzessNamen() As String)
    Dim lProzessNamenZeiger As Long                         'Zeiger fr For-Schleife
    Dim sProzessName As String                              'einzelner Name aus ProzessNamen-Feld
    Dim lProzessID As Long                                  'Die ID zum Prozess
    For lProzessNamenZeiger = LBound(ProzessNamen) To UBound(ProzessNamen) 'vom unteren zum oberen Ende des feldes
        sProzessName = ProzessNamen(lProzessNamenZeiger)    'Prozessname aus Feld lesen
        lProzessID = liefereProzessID(sProzessName)         'ID zum Prozess holen
        Do While lProzessID > 0                             'Wenn ID > 0 gibt es mindestens einen solchen Prozess ==> killen
            Call killProzessID(lProzessID)                  'den Prozess killen
            lProzessID = liefereProzessID(sProzessName)     'gibt es noch eine solchen Prozess? (Fr While)
        Loop
    Next lProzessNamenZeiger
End Sub

Public Function liefereProzessAnzahl(ByVal sProzessName As String) As Long
    Dim hSnapShot As Long, Result As Long, aa As String, bb As String
    Dim Process As PROCESSENTRY32
    Dim lErgebnis As Long
    lErgebnis = 0
    hSnapShot = CreateToolhelpSnapshot(TH32CS_SNAPPROCESS, 0&)
    If hSnapShot = 0 Then
        lErgebnis = 0
    Else
        Process.dwSize = Len(Process)
        Result = ProcessFirst(hSnapShot, Process)
        Do While Result <> 0
            aa = Process.szExeFile
            aa = Left$(aa, InStr(aa, Chr$(0)) - 1)
            If aa Like sProzessName Then
                lErgebnis = lErgebnis + 1
            End If
            Result = ProcessNext(hSnapShot, Process)
        Loop
        Call CloseHandle(hSnapShot)
    End If
    liefereProzessAnzahl = lErgebnis
End Function

Public Function liefereProzessName(ByVal lProzessID As Long) As String
    Dim hSnapShot As Long, Result As Long, aa As String, bb As String
    Dim Process As PROCESSENTRY32
    Dim sErgebnis As String
    sErgebnis = ""
    
    hSnapShot = CreateToolhelpSnapshot(TH32CS_SNAPPROCESS, 0&)
    If hSnapShot = 0 Then
        sErgebnis = ""
    Else
        Process.dwSize = Len(Process)
        Result = ProcessFirst(hSnapShot, Process)
        Do While Result <> 0
            If Process.th32ProcessID = lProzessID Then
                aa = Process.szExeFile
                aa = Left$(aa, InStr(aa, Chr$(0)) - 1)
                sErgebnis = aa
                Exit Do
            End If
            Result = ProcessNext(hSnapShot, Process)
        Loop
        Call CloseHandle(hSnapShot)
    End If
    liefereProzessName = sErgebnis
End Function

Public Function liefereProzessID(ByVal sProzessName As String) As Long
    Dim hSnapShot As Long, Result As Long, aa As String, bb As String
    Dim Process As PROCESSENTRY32
    Dim lErgebnis As Long
    lErgebnis = 0
    
    hSnapShot = CreateToolhelpSnapshot(TH32CS_SNAPPROCESS, 0&)
    If hSnapShot = 0 Then
        lErgebnis = 0
    Else
        Process.dwSize = Len(Process)
        Result = ProcessFirst(hSnapShot, Process)
        Do While Result <> 0
            aa = Process.szExeFile
            aa = Left$(aa, InStr(aa, Chr$(0)) - 1)
            If LCase(aa) = LCase(sProzessName) Then
                lErgebnis = Process.th32ProcessID
                Exit Do
            End If
            Result = ProcessNext(hSnapShot, Process)
        Loop
        Call CloseHandle(hSnapShot)
    End If
    liefereProzessID = lErgebnis
End Function

Public Sub killProzessID(ByVal lProzessID As Long)
   Dim lResult As Long
   Dim lTask As Long
   lTask = OpenProcess(PROCESS_TERMINATE, 0&, lProzessID)
   lResult = TerminateProcess(lTask, 1&)
   Call CloseHandle(lProzessID)
End Sub

Public Sub Pause(ByVal Seconds As Double, ByVal Events As Boolean)
    Dim t As Double
    t = TimeStamp(Seconds)
    Do Until TimeStamp >= t
        Sleep 100                   'org. Wert: 1
        If Events Then DoEvents
    Loop
End Sub

Public Function TimeStamp(Optional ByVal AdditionalSeconds As Double = 0) As Double
    TimeStamp = Int(Now) + (Timer + AdditionalSeconds) / 86400
End Function


