VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsSolidEdgeDraft"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Copyright (C) 2003  Jrgen Niesner, Stefan Rhrl
'This program is free software; you can redistribute it and/or modify it under the terms of the
'GNU General Public License as published by the Free Software Foundation; either version 2 of the
'License, or (at your option) any later version.

'This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
'even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License along with this program; if not,
'write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
'
'Auf Deutsch (ohen Garantie fr die bersetzung)
'Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der GNU General Public License,
'wie von der Free Software Foundation verffentlicht, weitergeben und/oder modifizieren, entweder gem
'Version 2 der Lizenz oder (nach Ihrer Option) jeder spteren Version.

'Die Verffentlichung dieses Programms erfolgt in der Hoffnung, da es Ihnen von Nutzen sein wird, aber
'OHNE IRGENDEINE GARANTIE, sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT FR
'EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License.

'Sie sollten eine Kopie der GNU General Public License zusammen mit diesem Programm erhalten haben. Falls
'nicht, schreiben Sie an die Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.

'=========================
'
'   changes
'         dah-1 09.02/2004 - shortend the loop to insert new sheets
'         dah-2 13.02/2004 - delete of sheets no longer supported, coding removed
'                          - exchange by form number: for custome sizes (-2) the
'                            width and height must match too
'         dah-3 11.03/2004 - the UserDefinedNames for a group will not be preserved
'                            by SE during a copy operation. Those names will now be
'                            saved in an attribute set created for each group whose
'                            UserDefinedName is not empty. This set will later be used
'                            to restore the original name for that group within the
'                            replaced background sheet. The attribute will be removed
'                            on the replaced sheet when empty but not on the new templates
'                            draft because it's not saved at end of run.
'         108 04.10,2004   - locale dependency on name of background sheet removed
'         109 21.07.2005   - Command 10211/10212 funktion changed by SE, <sheet>.activate
'                            will now be used instead
'         1010 01.11.2005  - change to handle new command functionality (10211/10212) was
'                            not correct and led to empty drafts when running in AutoMode
'                            Methods ersetzeHintergrundblaetter(), repOldData(), getNewData()
'                            changed
'         1011 07.12.2005  - with V17 after processing the screen was left in an undefined
'                            state (blank). To get the screen back manual interaction was
'                            neccessary
'                          - setting of user interaction to disabled has been removed
'                            Methods ersetzeHintergrundblaetter() changed
'         1012 03.01.2006  - RT was raised in Autorun mode, document was closed to early
'                            method ersetzeHintergrundblaetter() changed
'         1015 28.06.2006  - in autorun mode: window will be maximizid and the view set to fit
'                            so that the preview will show the whole draft. Screen flickering
'                            seems to be unavoidablewith this setting
'         1016 30.10.2006  - object of file to be changed not saved/restored which lead to an
'                            an invalid message and nothing was changed. Method setTemplate()
'                            changed
'                          - when a form is not found (-2, -1) the dimension will be given
'                          - template not closed at end, method ersetzeHintergrundblaetter() changed
'         1017 12.07.2007  - error handler in method ersetzeHintergrundblaetter() established
'                          - running in batch mode raised an RT, object VorlagenDraft was
'                            distroyed to early. Method ersetzeHintergrundblaetter() changed
'         1018 20.09.2007  - adjusted message in case the form does not match when exchange by
'                            sheetnames is in effect. Method: ersetzeHintergrundblaetter() changed
'         1021 16.02.2009  - separated document close from documet save; DrawingViewFit commented
'                            to avoid Screen Show/Hide; Method ersetzeHintergrundblaetter() changed
'         1022 10.07.2009  - any target layer that is non locatable will be set to locatable and after
'                            the replacement is set back to non locatable. Method repOldData() changed
'                          - any target block's name that does match a new templates block's name
'                            is deleted before the replacement is done. SE will not replace the block
'                            during the paste operation.
'         1023 27.07.2009  - invalid exchange processing when exchange done by sheet names. method
'                            ersetzeHintergrundblaetter() (near: zu ersetzendes Blatt suchen) changed
'         1024 28/07/2009  - runtime error 9 when new template has no blocks defined. Method
'                            getNewBlocks() changed
'         1025 12/01/2010  - command DetailEditDelete does not work with V100 and later. Command replaced
'                            by PartEditDelete (40212) as per advice by GTAC (PR#1758227 Prio 2 serious)
'                            PR will be fixed in V103. Method repOldData() changed.
'         1026 03/02/2014  - CommandID 11099 ("Paste to original Position") for ST6
'
'=========================
Option Explicit
Option Base 0
'
Const dDelay As Double = 0.1          ' delay zwischen den copy/paste/edit operationen
Const sAttrSetName As String = "$$CBSET1"   ' Name des Attribute-Sets
Const sAttrName As String = "$$CBATT1"      ' Name des Attributes
'
Private objSolidEdge As clsSolidEdge
Public objSeApp As SolidEdgeFramework.Application
Private seEigenschaften As clsSEEigenschaften
'
Private VorlagenDraft As SolidEdgeDraft.DraftDocument       ' neues template
Private AktuellesDraft As SolidEdgeDraft.DraftDocument
Private Blatt As SolidEdgeDraft.Sheet                       ' Blatt des 'alten' drafts
Private VorlagenBlatt As SolidEdgeDraft.Sheet               ' draft dessen Blatter zu ersetzen sind
Private objGroup As SolidEdgeFrameworkSupport.Group         ' fuer Ersetzen Gruppennamen
Private Fenster As Object                                   'SolidEdgeFramework.Window 'Object
Private seCommand As SolidEdgeFramework.Command
Private aryBlokName() As String                             ' will hold names of blocks to be deleted
'
Private bVorlagenSheetgefunden As Boolean
Private FileString As clsFileString
Private System As clsSystem3
Private sNewblatt As String
Private i As Long
Private lForm As Long
Private sFehler As String
Private clsNls As clsNlsConv
Private aNlsInsert() As String
Private isDocDirty As Boolean       ' true dataset changed
Private sSizeErr As String
Private sError As String
Private bCopyCustom As Boolean
Private bRepCustom As Boolean

Private Sub Class_Initialize()
'
    Set objSolidEdge = New clsSolidEdge
    Set objSeApp = objSolidEdge.liefereSolidEdgeApplication
    If Err.Number <> 0 Then
        sError = objSolidEdge.getError
        Exit Sub
    End If
    Set seEigenschaften = New clsSEEigenschaften
    '
End Sub

Private Sub Class_Terminate()
    On Error Resume Next
    Set System = Nothing
    '
    'If Not (VorlagenDraft Is Nothing) Then
       'Call VorlagenDraft.Close(False)              ' close template
       Set VorlagenDraft = Nothing
    'End If
    '
    Set seEigenschaften = Nothing
    Set objSeApp = Nothing
    Set objSolidEdge = Nothing
    Set clsNls = Nothing
End Sub

Public Property Get getError() As String
'
    getError = sError
'
End Property
Public Property Get getDocCount() As Long
    getDocCount = objSeApp.Documents.Count
End Property

Public Property Let setSystem(pSystem As clsSystem3)
    Set System = pSystem
End Property

Public Property Let setNls(pClsNls As clsNlsConv)
    Set clsNls = pClsNls
End Property

Public Property Let setCpyCust(pCpy As Boolean)
    bCopyCustom = pCpy
End Property

Public Property Let setRepCust(pRep As Boolean)
    bRepCustom = pRep
End Property

Public Function setTemplate(pVorlage As DraftDocument) As Boolean
'
Dim currObj As Object
'
    If objSeApp.Documents.Count <> 0 Then
        Set currObj = objSeApp.ActiveDocument ' save current file
    End If
    '
    setTemplate = False
    Set VorlagenDraft = pVorlage 'objSolidEdge.liefereSolidEdgeDraftDokument(sNeueVorlage)  ' template file
'
    'If Not (VorlagenDraft Is Nothing) Then
        Call saveGroupNames(newTemplates:=VorlagenDraft)     ' save group names
        setTemplate = True
    'End If
    '
    ' restore the file to be changed
    If Not currObj Is Nothing Then
        Call currObj.Activate
        Set currObj = Nothing
    End If
    '
End Function
'
'-------------------------------------------
' collect all blocks that the new template may have. These will be needed
' to delete equal named blocks within the target draft. A delete of the
' old content and replace it with the new one will not replace the block
'
Public Function getNewBlocks(pDoc As DraftDocument) As Boolean
'
Static i As Long
Static objBlk As Block

'

    On Error GoTo err_handler:
    getNewBlocks = False
    ReDim aryBlokName(0)          ' init array so not to fail later on
    '
    If pDoc.Blocks.Count < 1 Then
        GoTo cleanup
    End If
    '
    i = 0
    ReDim aryBlokName(pDoc.Blocks.Count)
    For Each objBlk In pDoc.Blocks
        aryBlokName(i) = objBlk.Name
        i = i + 1
    Next objBlk
    getNewBlocks = True
cleanup:
    Set objBlk = Nothing
    Exit Function
err_handler:
    sError = "getNewBlocks(): " & Err.Number & " / " & Err.Description
    Call logWrite(clsNls.getString("clsSed.methodFail", 0, sError))
    Resume cleanup:
End Function
'---------------------------------------------------------------------------------------
' Procedure : ersetzeHintergrundblaetter
' DateTime  : 16.12.2002 07:12
' Author    : Niesner
' Purpose   : Tauscht die Hintergrundbltter des Activen Dokuments gegen die Hintergrundbltter
'             des Drafts sneueVorlage aus und liefert bei Erfolg 0
' ChangeLog : Aktualisierung der Eigenschaft fr VorlagenName eingefgt (14.10.2003 15:26, Niesner)
'           : 07.02.2004 Dah - SummaryInformation: setzen Vorlage: bei Fehler mit 'Template'
'                              versuchen (Locale US/EN)
'                            - Pause auf 0.25 Sec gesetzt, OK
'---------------------------------------------------------------------------------------
'
Public Function ersetzeHintergrundblaetter(ByVal sNeueVorlage As String, _
                                            sRepl() As String, _
                                            pbAutoRun As Boolean, _
                                            Optional sDokument As String = vbNullString) As Boolean
Dim lErr As Long
Dim lTemp As Long
Dim UOM As UnitsOfMeasure
Dim bHaveWrite As Boolean
Dim objTemp As Object
Dim objBlk As Block
Dim i As Long
'
    On Error GoTo err_handler:      ' default this one
    objSeApp.Activate
    ersetzeHintergrundblaetter = False
    isDocDirty = False
    sError = vbNullString
    '
    ' open dokument (Auto mode)
    On Error Resume Next
    If sDokument <> vbNullString Then
        objSeApp.DisplayAlerts = False
        objSeApp.Visible = False
        Set objTemp = objSeApp.Documents.Open(FileName:=sDokument)
        If Err.Number <> 0 Then
            If (Err.Number And vbObjectError) Then
                lErr = Err.Number Xor vbObjectError
            Else
                lErr = Err.Number
            End If
            ReDim aNlsInsert(2)
            aNlsInsert(0) = sDokument
            aNlsInsert(1) = lErr
            aNlsInsert(2) = Err.Description
            Call logWrite(clsNls.getString("clsSed.errOpen", 0, aNlsInsert()))
            GoTo cleanup:
        End If
    End If
    '
    ' common processing
    On Error GoTo err_handler
    Call logWrite(clsNls.getString("clsSed.theDoc", 0, objSeApp.ActiveDocument.FullName))
    '
    ' if write protected we'll skip to avoid SE message
    If objSeApp.ActiveDocument.ReadOnly Then
        Call objSeApp.ActiveDocument.SeekWriteAccess(bHaveWrite)
        If Not bHaveWrite Then
            If pbAutoRun Then
                Call logWrite(clsNls.getString("clsSed.isWriteProt", 0, vbNullString))
                Call objSeApp.ActiveDocument.Close(False)        ' no saving
                GoTo cleanup:
            End If
        End If
    End If
    '
    ' firmenspezifisch: auskommentiert
    'If anlegenGedasSchriftfeldProperties() = False Then
    '    Call logWrite(clsNls.getString("clsSed.noGedas", 0, vbNullString))
    'End If
    '
    If Not (objSeApp.ActiveDocumentType = igDraftDocument) Then                 ' Draft-Dokument ?
        sFehler = clsNls.getString("clsSed.noDraft", 0, vbNullString)
        Call setMsg(pbAutoRun)
        GoTo cleanup:
    End If
    '
    ' check if we are about to process the new backgrounds
    If UCase$(objSeApp.ActiveDocument.FullName) = UCase$(sNeueVorlage) Then ' identical ?
        sFehler = clsNls.getString("clsSed.isTempl", 0, vbNullString)
        Call setMsg(pbAutoRun)
        GoTo cleanup:
    End If
    '
    ' Notwendig weil sonst bei 'Autorun Modus"
    ' Fenster.SelectSet.AddAll einen run-time error bringt
    ' es kann notwendig sein zusaetzlich visible auf true
    ' zu setzen
    If CLng(Left(objSeApp.Version, InStr(1, objSeApp.Version, ".", vbTextCompare) - 1)) > 14 Then
        'objSeApp.Visible = True
        objSeApp.WindowState = vbMinimized        ' window minimiert
    End If
    '
    ' Verarbeitung
    '
    Set AktuellesDraft = objSeApp.ActiveDocument                            ' altes Draft
    Set UOM = AktuellesDraft.UnitsOfMeasure
    '
    ' delete matching blocks in target draft
    If aryBlokName(0) <> vbNullString Then
        For Each objBlk In AktuellesDraft.Blocks
            For i = 0 To UBound(aryBlokName) - 1
                If StrComp(aryBlokName(i), objBlk.Name, vbTextCompare) = 0 Then
                    objBlk.Delete
                    Exit For
                End If
            Next i
        Next objBlk
    End If
    '
    If Not pbAutoRun Then
        frmVorlagenAuswahl.PBar1.Max = AktuellesDraft.Sections(2).Sheets.Count
        frmVorlagenAuswahl.maxSheet = frmVorlagenAuswahl.PBar1.Max
    End If
    '
    For Each Blatt In AktuellesDraft.Sections(2).Sheets                     ' in jedem Blatt
        bVorlagenSheetgefunden = False
        
        '
        ' Wenn nach Formnummern sNewblatt auf <> leer setzen
        If bForm Then
            sNewblatt = Blatt.Name
        Else
            '
            ' zu ersetzendes Blatt suchen
            sNewblatt = vbNullString
            For i = 0 To UBound(sRepl)
                If Not (sRepl(i, 0) = vbNullString And sRepl(i, 1) = vbNullString) Then
                    If Blatt.Name = sRepl(i, 0) Then
                        sNewblatt = sRepl(i, 1)    ' maybe empty when to be left untouched
                        Exit For
                    End If
                End If
            Next i
        End If
        sSizeErr = vbNullString        ' reset forms -2 size no match message
        '
        ' Blatt gefunden ?
        If sNewblatt <> vbNullString Then
            bVorlagenSheetgefunden = False
            For Each VorlagenBlatt In VorlagenDraft.Sections(2).Sheets          ' jede Vorlage austauschen
                VorlagenBlatt.Activate
                If bForm Then         ' exchange by form number ?
                    If chkForms() Then
                        Exit For
                    End If
                Else                  ' no, by sheet names
                    If chkNames(pbAutoRun) Then
                        Exit For
                    End If
                End If
            Next
        End If
        '
        ' wenn nichts passendes Message
        If Not bVorlagenSheetgefunden Then
            If sSizeErr = vbNullString Then
                If bForm Then
                    ReDim aNlsInsert(3)
                    aNlsInsert(0) = Blatt.Name
                    aNlsInsert(1) = CStr(Blatt.SheetSetup.SheetSizeOption)
                    aNlsInsert(2) = CStr(UOM.FormatUnit(igUnitDistance, Blatt.SheetSetup.SheetWidth))
                    aNlsInsert(3) = CStr(UOM.FormatUnit(igUnitDistance, Blatt.SheetSetup.SheetHeight))
                    Call logWrite(clsNls.getString("clsSed.noChange", 0, aNlsInsert()))
                Else
                    If sNewblatt <> vbNullString Then
                        ReDim aNlsInsert(1)
                        aNlsInsert(0) = Blatt.Name
                        aNlsInsert(1) = sNewblatt
                        Call logWrite(clsNls.getString("clsSed.noSheet", 0, aNlsInsert()))
                    End If
                End If
            Else
                Call logWrite(sSizeErr)
            End If
        Else
            Call repOldData(False)
            ReDim aNlsInsert(1)
            aNlsInsert(0) = Blatt.Name
            aNlsInsert(1) = sNewblatt
            Call logWrite(clsNls.getString("clsSed.SheetChanged", 0, aNlsInsert()))
        End If
    '
    ' update progressmeter
    If Not pbAutoRun Then
        frmVorlagenAuswahl.PBar1.Value = frmVorlagenAuswahl.PBar1.Value + 1
        frmVorlagenAuswahl.minSheet = frmVorlagenAuswahl.PBar1.Value
        DoEvents
    End If
    '
    Next       '  /* For Each Blatt In .... */
    '
    ' neue Blaetter einfuegen
    ' Note: nur bei Verwendung von Austausch nach Blattnamen
    '
    For i = 0 To UBound(sRepl)
        If sRepl(i, 0) = vbNullString And sRepl(i, 1) <> vbNullString Then
            sNewblatt = sRepl(i, 1)
            On Error Resume Next
            Set VorlagenBlatt = VorlagenDraft.Sections(2).Sheets(sNewblatt)
            If Err.Number <> 0 Then
                Call logWrite(clsNls.getString("clsSed.notFound", 0, sNewblatt))
                On Error GoTo err_handler
            Else
                On Error GoTo err_handler
                lForm = VorlagenBlatt.SheetSetup.SheetSizeOption
                If getNewData Then
                    If repOldData(True) Then
                        Call logWrite(clsNls.getString("clsSed.inserted", 0, sNewblatt))
                        isDocDirty = True
                    End If
                End If
            End If    ' /* If Err.Number <> 0 */
        End If   ' /* If sRepl(i, 0) = vbNullString ... */
    Next i
    '
    ' Endverarbeitung
    '
    AktuellesDraft.Activate
    Set FileString = New clsFileString
    '
    ' Eigenschaft auf neue Vorlage setzen
    ' nur wenn etwas getauscht/geloescht wurde
    '
    If isDocDirty Then
        On Error Resume Next
        AktuellesDraft.Properties("SummaryInformation").PropertyByID(siTemplate).Value = FileString.ermittleDateiname(sNeueVorlage)
        If Err.Number <> 0 Then
            ' ignore but write log
            Call logWrite(clsNls.getString("clsSed.noUpdte", 0, vbNullString))
        End If
        On Error GoTo err_handler:
    End If
    '
    ' postprocessing
    '
    If lSeVersion > 15 Then
        AktuellesDraft.Sections.WorkingSection.Sheets.Item(1).Activate   ' any sheet will do
        Call objSeApp.StartCommand(DetailViewBackgroundSheet)         ' will set checkmark off
    Else
        Call objSeApp.StartCommand(DetailViewWorkingsheet)        ' work on (V16-)
    End If
    '
    ' call fails intermittend, so we ignore the error here
    On Error Resume Next
    AktuellesDraft.UpdatePropertyTextCacheAndDisplay
    Err.Clear
    On Error GoTo err_handler:
    '
    '
    If pbAutoRun Then
        On Error Resume Next
        If bCopyCustom Then
            Call copyCustom
        End If
        'objSeApp.WindowState = vbMaximized        ' window Max (will show screen)
        'objSeApp.StartCommand (DrawingViewEditViewFit)
        objSeApp.Visible = False                  ' screen off
        If isDocDirty Then
            Call objSeApp.ActiveDocument.Save  'if doc is changed isDocDirty = true
        End If
        Call objSeApp.ActiveDocument.Close(False)
        If Err.Number <> 0 Then
            If (Err.Number And vbObjectError) Then
                lErr = Err.Number Xor vbObjectError
            Else
                lErr = Err.Number
            End If
            ReDim aNlsInsert(1)
            aNlsInsert(0) = CStr(lErr)
            aNlsInsert(1) = Err.Description
            Call logWrite(clsNls.getString("clsSed.noUpdte", 0, aNlsInsert()))
        End If
        'objSeApp.WindowState = vbMinimized        ' window min
        'objSeApp.Visible = True
    Else
        objSeApp.WindowState = vbMaximized        ' window Max
        If bCopyCustom Then
            Call copyCustom
        End If
    End If
    '
    ' Exit
    '
Good_Exit:
    '
    ersetzeHintergrundblaetter = True            ' happy rc
cleanup:
    On Error Resume Next
    Set FileString = Nothing
    Set UOM = Nothing
    Set Blatt = Nothing
    Set objTemp = Nothing
    If Not ersetzeHintergrundblaetter And Not AktuellesDraft Is Nothing Then
        Call AktuellesDraft.Close(False)
    End If
    Set AktuellesDraft = Nothing
   '
    Exit Function
'
err_handler:
    sError = "ersetzeHintergrundblaetter(): " & Err.Number & " / " & Err.Description
    Call logWrite(clsNls.getString("clsSed.methodFail", 0, sError))
    Resume cleanup:
    '
End Function
'
Private Function copyCustom() As Boolean
'
Static vTemp As Variant
Static sTemp As String
'
    On Error GoTo err_handler
    copyCustom = False
    '
    For Each vTemp In VorlagenDraft.Properties.Item("Custom")
        On Error Resume Next
        sTemp = AktuellesDraft.Properties.Item("Custom").Item(vTemp.Name)
        If Err.Number <> 0 Or bRepCustom Then
            Call AktuellesDraft.Properties.Item("Custom").Add(vTemp.Name, vTemp.Value)
            Err.Clear
        End If
        On Error GoTo err_handler
    Next
    copyCustom = True
    Exit Function
err_handler:
    sError = "copyCustom(): " & Err.Number & " / " & Err.Description
    Call logWrite(clsNls.getString("clsSed.methodFail", 0, sError))
    Exit Function

End Function
'---------------------------------------------------------------------------------------
' Procedure : saveGroups
' DateTime  : 11.03.2004
' Author    : Dahlenburg
' Purpose   : sichert die benuzerdefinierten Gruppennamen in ein Attribut eines
'             Attribute-Sets. Dies ist notwendig um in dem ausgetauschten Hintergrund-
'             Blatt den Namen wieder einsetzen zu koennen da SE disen nicht kopiert
'             sondern den interne Gruppennamen einsetzt (Group 1234)
' Note      : die Attribute-Sets der neuen Vorlage werden nicht geloescht, da diese
'             am Ende nicht gesichert wird. Diese Routine wird einmalig zu Beginn
'             des Austausches durchlaufen.
' Parameter : keine
' Required  : aktives Draft, Variable: objGroup und VorlagenBlatt
' Return    : n/a
' ToDo      :
'---------------------------------------------------------------------------------------
'
Private Sub saveGroupNames(newTemplates As SolidEdgeDraft.DraftDocument)
'
Static newSheet As SolidEdgeDraft.Sheet
'
    On Error GoTo Err_exit:
    '
    newTemplates.Activate
    ' ======== Call objSeApp.StartCommand(DetailViewBackgroundSheet)       'Hintergrundblatt
    If lSeVersion > 15 Then
        newTemplates.Sections.BackgroundSection.Sheets.Item(1).Activate   ' any sheet will do
    Else
        Call objSeApp.StartCommand(DetailViewBackgroundSheet)        ' work on (V16-)
    End If
    newTemplates.ActiveSheet.Activate
    For Each VorlagenBlatt In newTemplates.Sections(2).Sheets
        VorlagenBlatt.Activate
        For Each objGroup In VorlagenBlatt.Groups
            If objGroup.UserDefinedName <> vbNullString Then
                objGroup.AttributeSets.Add CStr(sAttrSetName)
                With objGroup.AttributeSets.Item(objGroup.AttributeSets.Count)
                    .Add CStr(sAttrName), seStringANSI
                    '
                    ' save name plus locatable True/False
                    .Item(.Count).Value = CStr(objGroup.UserDefinedName) & IIf(objGroup.Locatable, "|1", "|0") ' save the group's name
                    objGroup.Locatable = True   ' must be true otherwise it is not copied
                End With
            End If
        Next
    Next
Err_exit:
'
End Sub
'---------------------------------------------------------------------------------------
' Procedure : chkForms
' DateTime  : 13.02.2004
' Author    : Dahlenburg
' Purpose   : prueft ob die Formnummern und fuer Form = -2 die Blattgroessen
'             uebereinstimmen
' Parameter : keine
' Required  : String sSizeErr falls bei -2 Blattgroesse nicht stimmt
' Return    : True = Blatt verarbeitet, False andernfalls
' ToDo      :
'---------------------------------------------------------------------------------------
'
Private Function chkForms() As Boolean
    chkForms = False
    ' If form numbers match and if form is custom size
    ' then the width and height must match too
    If VorlagenBlatt.SheetSetup.SheetSizeOption = Blatt.SheetSetup.SheetSizeOption Then
        If chkSize(sSizeErr) Then
            Call getNewData
            bVorlagenSheetgefunden = True
            sNewblatt = VorlagenBlatt.Name
            isDocDirty = True
            chkForms = True
        End If
    End If  ' /* If VorlagenBlatt.SheetSetup ... */

End Function
'---------------------------------------------------------------------------------------
' Procedure : chkNames
' DateTime  : 13.02.2004
' Author    : Dahlenburg
' Purpose   : prueft ob die Blattnamen/Formnummern und fuer Form = -2 die Blattgroessen
'             uebereinstimmen
' Parameter : Boolean True fuer Batchlauf (AutoRun), ansonsten False
' Required  : String sSizeErr falls bei -2 Blattgroesse nicht stimmt
' Return    : True = Blatt verarbeitet, False andernfalls
' ToDo      :
'---------------------------------------------------------------------------------------
'
Private Function chkNames(pAutoRun As Boolean) As Boolean
'
    chkNames = False
    If VorlagenBlatt.Name <> sNewblatt Then
        Exit Function
    End If
    '
    If pAutoRun Then
        Call getNewData
        bVorlagenSheetgefunden = True
        isDocDirty = True
        chkNames = True
        Exit Function
    End If
    '
    If chkSize(sSizeErr) Then
        If VorlagenBlatt.SheetSetup.SheetSizeOption = Blatt.SheetSetup.SheetSizeOption Then
            Call getNewData
            bVorlagenSheetgefunden = True
            isDocDirty = True
            chkNames = True
        Else
            ReDim aNlsInsert(3)
            aNlsInsert(0) = CStr(Blatt.SheetSetup.SheetSizeOption)
            aNlsInsert(1) = Blatt.Name
            aNlsInsert(2) = CStr(VorlagenBlatt.SheetSetup.SheetSizeOption)
            aNlsInsert(3) = VorlagenBlatt.Name
            sFehler = clsNls.getString("clsSed.noMatch", 0, aNlsInsert())
            Call setMsg(pAutoRun)
            chkNames = True
        End If
    End If

End Function
'---------------------------------------------------------------------------------------
' Procedure : chkSize
' DateTime  : 12.02.2004
' Author    : Dahlenburg
' Purpose   : prueft die Blattgroesse bei 'Custom Size'
' Parameter : String fuer eine Fehlernachricht
' Required  : none
' Return    : True = Blattgroesse stimmt ueberein, False andernfalls und sFehler <> leer
' ToDo      :
'---------------------------------------------------------------------------------------
'
Private Function chkSize(pFehler) As Boolean
    chkSize = False
    pFehler = vbNullString
    If VorlagenBlatt.SheetSetup.SheetSizeOption <> igCustomSheetSize Then
        chkSize = True
        Exit Function
    End If
    '
    If Round(VorlagenBlatt.SheetSetup.SheetHeight, 3) = Round(Blatt.SheetSetup.SheetHeight, 3) And _
        Round(VorlagenBlatt.SheetSetup.SheetWidth, 3) = Round(Blatt.SheetSetup.SheetWidth, 3) Then
        chkSize = True
        Exit Function
    End If
    '
    ' set message
    ReDim aNlsInsert(1)
    aNlsInsert(0) = CStr(Blatt.SheetSetup.SheetSizeOption) & " Format: " _
                    & Format(Blatt.SheetSetup.SheetWidth, "0.000") & " x " _
                    & Format(Blatt.SheetSetup.SheetHeight, "0.000")
    aNlsInsert(1) = Blatt.Name
    pFehler = clsNls.getString("clsSed.noSizeMatch", 0, aNlsInsert())
    '
End Function
'---------------------------------------------------------------------------------------
' Procedure : getNewData
' DateTime  : 07.02.2004
' Author    : Dahlenburg
' Purpose   : kopiert den Inhalt der neuen Vorlage in die Zwischenablage
' ToDo      :
'---------------------------------------------------------------------------------------
'
Private Function getNewData() As Boolean
'
    On Error GoTo Error_exit:
    
    getNewData = False
    sFehler = vbNullString
    '
    VorlagenDraft.Activate
    If CLng(Left(objSeApp.Version, InStr(1, objSeApp.Version, ".", vbTextCompare) - 1)) > 15 Then
        VorlagenDraft.Sections.BackgroundSection.Sheets.Item(1).Activate   ' any sheet will do
    Else
        Call objSeApp.StartCommand(DetailViewBackgroundSheet)        ' backgnd on (V16-)
    End If
    VorlagenBlatt.Activate
    Set Fenster = objSeApp.ActiveWindow
    'Fenster.Visible = false
    Fenster.SelectSet.RemoveAll                                 'Selectset leeren
    Fenster.SelectSet.AddAll                                    'alles auswhlen
    Call System.Pause(dDelay, True)
    Call objSeApp.StartCommand(DetailEditCopy)                  'kopieren
    Call System.Pause(dDelay, True)
    getNewData = True
    '
    Exit Function
Error_exit:
    Call logWrite(clsNls.getString("clsSed.methodFail", 0, "Fehler in der Methode getNewData(): " & Err.Description))
    
End Function
'---------------------------------------------------------------------------------------
' Procedure : repOldData
' DateTime  : 07.02.2004
' Author    : Dahlenburg
' Purpose   : kopiert den Inhalt der Zwischenablage in das aktuelle Hintergrundblatt
'             und setzt den UserDefinedName einer gruppe wieder auf den Original-Namen
'             sofern ein entsprechender Attribute-Set gefunden wurde. Der Set wird
'             anschliessend geloescht.
' ToDo      :
'---------------------------------------------------------------------------------------
'
Private Function repOldData(Optional bNewSheet As Boolean = False) As Boolean
'
Static i As Long
Static j As Long
Static sTemp As String
Static tmpLayer As Layer
Dim objLayer() As Layer
'
    repOldData = False
    sFehler = vbNullString
    '
    AktuellesDraft.Activate
    If CLng(Left(objSeApp.Version, InStr(1, objSeApp.Version, ".", vbTextCompare) - 1)) > 15 Then
        VorlagenDraft.Sections.BackgroundSection.Sheets.Item(1).Activate   ' any sheet will do
    Else
        Call objSeApp.StartCommand(DetailViewBackgroundSheet)        ' backgnd on (V16-)
    End If
    '
    If bNewSheet Then
        On Error Resume Next
        Set Blatt = AktuellesDraft.Sheets.AddSheet(sNewblatt, igBackgroundSection)
        ' if we fail here then most likely it's a programming error
        If Err.Number <> 0 Then
            Call logWrite(clsNls.getString("clsSed.dupSheet", 0, sNewblatt))
            Blatt.Delete
            Clipboard.Clear
            Exit Function
        End If
        On Error GoTo Error_exit:             ' resume error handler
        Blatt.SheetSetup.SheetSizeOption = lForm
    End If
    On Error GoTo Error_exit:            ' enable error handler
    '
    Blatt.Activate
    '
    ' reset locatable setting to locatable
    ReDim objLayer(Blatt.Layers.Count)
    i = 0
    For Each tmpLayer In Blatt.Layers
        If Not tmpLayer.Locatable Then
            tmpLayer.Locatable = True
            Set objLayer(i) = tmpLayer
        End If
    Next tmpLayer
    '
    Set Fenster = objSeApp.ActiveWindow
    'Fenster.Visible = False
    Fenster.SelectSet.RemoveAll
    Fenster.SelectSet.AddAll
    Call System.Pause(dDelay, True)
    '      =============> API Error
    ' changed on information by GTAC to 40212 (PartEditDelete) for V100+ only
    If lSeVersion <= 100 Then
        Call objSeApp.StartCommand(DetailEditDelete)           'alle markierten Elemente lschen
    Else
        Call objSeApp.StartCommand(PartEditDelete)             'alle markierten Elemente lschen
    End If
    Call System.Pause(dDelay, True)
    
    '03.02.2014 --> CommandID 11099 ("Paste to original Position") for ST6
    Call objSeApp.StartCommand(11099) '11099-->"Paste to original Position"
    'Call objSeApp.StartCommand(DetailEditPaste)                 'Zwischenablage einfgen
        
    Call System.Pause(dDelay, True)
    '
    ' restore locatable setting
    For i = 0 To UBound(objLayer) - 1
        If Not (objLayer(i) Is Nothing) Then
            objLayer(i).Locatable = False
        Else
            Exit For
        End If
    Next i
    '
    ' ersetzen UserDefinedName einer Gruppe und
    ' loeschen des Attribute-Sets wenn leer
    For Each objGroup In Blatt.Groups
        If objGroup.IsAttributeSetPresent(sAttrSetName) Then
            With objGroup.AttributeSets
                '
                ' loop over all sets in this group
                For i = .Count To 1 Step -1
                    If .Item(i).SetName = CStr(sAttrSetName) Then
                        '
                        ' loop over all attributes in this set
                        For j = .Item(i).Count To 1 Step -1
                            If .Item(i).Item(j).Name = CStr(sAttrName) Then
                               '
                               ' name without locatable option
                               objGroup.UserDefinedName = Left(.Item(i).Item(j).Value, Len(.Item(i).Item(j).Value) - 2) ' set group name
                               '
                               ' now recover the locatable option
                               objGroup.Locatable = IIf(Right(.Item(i).Item(j).Value, 1) = "1", True, False)
                              .Item(i).Remove (CStr(sAttrName))  ' remove attribute
                            End If
                        Next j
                    End If
                    '
                    ' remove set when empty
                    If .Item(i).Count < 1 Then
                        .Remove CStr(sAttrSetName)
                    End If
                Next i  ' /* For i = .Count ... */
            End With
            '
        End If ' /* if objGroup.IsAttributeSet... */
        '
    Next  '  /* For Each objGroup ... */
    repOldData = True
cleanup:
    On Error Resume Next
    Erase objLayer
    Set tmpLayer = Nothing
    Exit Function
    '
Error_exit:
    Call logWrite(clsNls.getString("clsSed.methodFail", 0, "Fehler in der Methode repOldData(): " & Err.Description))
    Resume cleanup
End Function

'---------------------------------------------------------------------------------------
' Procedure : schreibeGedasSchriftfeldProperties
' DateTime  : 19.02.2003 11:57
' Author    : Niesner
' Purpose   : Schreibt Werte des Schriftfeldes in die entsprechenden BenutzerProperties,
'           : Werte die von Gedas evtl. berschrieben werden werden doppelt gespeichert (MR-....)
' ToDo      : umbauen auf ByRef auf einen String und nicht auf eine TextBox, damit wiederverwendbar
'---------------------------------------------------------------------------------------
'
Public Function schreibeGedasSchriftfeldProperties(ByRef sDrawingDrawDescription As TextBox, _
            ByRef sDrawingDrawDocumentType As TextBox, _
            ByRef sDrawingDrawDocumentNumber As TextBox, _
            ByRef sDrawingDrawDocumentPart As TextBox, _
            ByRef sDrawingDrawDocumentVersion As TextBox, _
            ByRef sDrawingDrawECNumber As TextBox, _
            ByRef sDrawingMaraMatNr As TextBox, _
            ByRef sDrawingDrawPADatum As TextBox, _
            ByRef sDrawingDrawPAName As TextBox, _
            ByRef sDrawingDrawK1Datum As TextBox, _
            ByRef sDrawingDrawK1Name As TextBox, _
            ByRef sDrawingDrawNKDatum As TextBox, _
            ByRef sDrawingDrawNKName As TextBox, _
            ByRef sDrawingCADWerkstoff As TextBox, _
            ByRef sDrawingCADMassStab As TextBox, _
            ByRef sDrawingCADZusatzMassStab As TextBox, _
            Optional ByRef SEDraftDatei As SolidEdgeDraft.DraftDocument = Nothing) As Boolean
    Dim lErgebnis As Boolean
    Dim PropSets As SolidEdgeFramework.PropertySets
    Dim Properties As SolidEdgeFramework.Properties
    
    lErgebnis = False
    
    If Len(sDrawingDrawDescription.Text) = 0 Then sDrawingDrawDescription.Text = "-"
    If Len(sDrawingDrawDocumentType.Text) = 0 Then sDrawingDrawDocumentType.Text = "-"
    If Len(sDrawingDrawDocumentNumber.Text) = 0 Then sDrawingDrawDocumentNumber.Text = "-"
    If Len(sDrawingDrawDocumentPart.Text) = 0 Then sDrawingDrawDocumentPart.Text = "-"
    If Len(sDrawingDrawDocumentVersion.Text) = 0 Then sDrawingDrawDocumentVersion.Text = "-"
    If Len(sDrawingDrawECNumber.Text) = 0 Then sDrawingDrawECNumber.Text = "-"
    If Len(sDrawingMaraMatNr.Text) = 0 Then sDrawingMaraMatNr.Text = "-"
    If Len(sDrawingDrawPADatum.Text) = 0 Then sDrawingDrawPADatum.Text = "-"
    If Len(sDrawingDrawPAName.Text) = 0 Then sDrawingDrawPAName.Text = "-"
    If Len(sDrawingDrawK1Datum.Text) = 0 Then sDrawingDrawK1Datum.Text = "-"
    If Len(sDrawingDrawK1Name.Text) = 0 Then sDrawingDrawK1Name.Text = "-"
    If Len(sDrawingDrawNKDatum.Text) = 0 Then sDrawingDrawNKDatum.Text = "-"
    If Len(sDrawingDrawNKName.Text) = 0 Then sDrawingDrawNKName.Text = "-"
    If Len(sDrawingCADWerkstoff.Text) = 0 Then sDrawingCADWerkstoff.Text = "-"
    If Len(sDrawingCADMassStab.Text) = 0 Then sDrawingCADMassStab.Text = "-"
    If Len(sDrawingCADZusatzMassStab.Text) = 0 Then sDrawingCADZusatzMassStab.Text = "-"
    
    On Error Resume Next
        Err.Clear
        If SEDraftDatei Is Nothing Then
            Set SEDraftDatei = objSeApp.ActiveDocument
        End If
        With seEigenschaften
            Call .schreibePropertie(SEDraftDatei, "Custom", "DRAWING-DRAW-DESCRIPTION", sDrawingDrawDescription.Text)
            Call .schreibePropertie(SEDraftDatei, "Custom", "DRAWING-DRAW-DOCUMENTTYPE", sDrawingDrawDocumentType.Text)
            Call .schreibePropertie(SEDraftDatei, "Custom", "DRAWING-DRAW-DOCUMENTNUMBER", sDrawingDrawDocumentNumber.Text)
            Call .schreibePropertie(SEDraftDatei, "Custom", "DRAWING-DRAW-DOCUMENTPART", sDrawingDrawDocumentPart.Text)
            Call .schreibePropertie(SEDraftDatei, "Custom", "DRAWING-DRAW-DOCUMENTVERSION", sDrawingDrawDocumentVersion.Text)
            Call .schreibePropertie(SEDraftDatei, "Custom", "DRAWING-DRAW-ECNUMBER", sDrawingDrawECNumber.Text)
            Call .schreibePropertie(SEDraftDatei, "Custom", "DRAWING-MARA-MATNR", sDrawingMaraMatNr.Text)
            Call .schreibePropertie(SEDraftDatei, "Custom", "DRAWING-PA-DATUM", sDrawingDrawPADatum.Text)
            Call .schreibePropertie(SEDraftDatei, "Custom", "DRAWING-PA-NAME", sDrawingDrawPAName.Text)
            Call .schreibePropertie(SEDraftDatei, "Custom", "DRAWING-K1-DATUM", sDrawingDrawK1Datum.Text)
            Call .schreibePropertie(SEDraftDatei, "Custom", "DRAWING-K1-NAME", sDrawingDrawK1Name.Text)
            Call .schreibePropertie(SEDraftDatei, "Custom", "DRAWING-NK-DATUM", sDrawingDrawNKDatum.Text)
            Call .schreibePropertie(SEDraftDatei, "Custom", "DRAWING-NK-NAME", sDrawingDrawNKName.Text)
            Call .schreibePropertie(SEDraftDatei, "Custom", "DRAWING-CAD_WERKSTOFF", sDrawingCADWerkstoff.Text)
            Call .schreibePropertie(SEDraftDatei, "Custom", "DRAWING-CAD_MASSSTAB", sDrawingCADMassStab.Text)
            Call .schreibePropertie(SEDraftDatei, "Custom", "DRAWING-CAD_ZUSATZMASSSTAB", sDrawingCADZusatzMassStab.Text)
            Call .schreibePropertie(SEDraftDatei, "Custom", "MR-DRAWING-PA-DATUM", sDrawingDrawPADatum.Text)
            Call .schreibePropertie(SEDraftDatei, "Custom", "MR-DRAWING-PA-NAME", sDrawingDrawPAName.Text)
            Call .schreibePropertie(SEDraftDatei, "Custom", "MR-DRAWING-K1-DATUM", sDrawingDrawK1Datum.Text)
            Call .schreibePropertie(SEDraftDatei, "Custom", "MR-DRAWING-K1-NAME", sDrawingDrawK1Name.Text)
            Call .schreibePropertie(SEDraftDatei, "Custom", "MR-DRAWING-NK-DATUM", sDrawingDrawNKDatum.Text)
            Call .schreibePropertie(SEDraftDatei, "Custom", "MR-DRAWING-NK-NAME", sDrawingDrawNKName.Text)
        End With
    On Error GoTo 0
    Call SEDraftDatei.UpdatePropertyTextCacheAndDisplay
    schreibeGedasSchriftfeldProperties = lErgebnis
End Function

'---------------------------------------------------------------------------------------
' Procedure : leseGedasSchriftfeldProperties
' DateTime  : 19.02.2003 12:00
' Author    : Niesner
' Purpose   : liest aus den BenutzerProperties die Werte fr das Schriftfeld, prft die alternativen
'           : Properties (MR-...) falls GEDAS-Standard-Properties leer sind
'---------------------------------------------------------------------------------------
'
Public Function leseGedasSchriftfeldProperties(ByRef sDrawingDrawDescription As TextBox, _
            ByRef sDrawingDrawDocumentType As TextBox, _
            ByRef sDrawingDrawDocumentNumber As TextBox, _
            ByRef sDrawingDrawDocumentPart As TextBox, _
            ByRef sDrawingDrawDocumentVersion As TextBox, _
            ByRef sDrawingDrawECNumber As TextBox, _
            ByRef sDrawingMaraMatNr As TextBox, _
            ByRef sDrawingDrawPADatum As TextBox, _
            ByRef sDrawingDrawPAName As TextBox, _
            ByRef sDrawingDrawK1Datum As TextBox, _
            ByRef sDrawingDrawK1Name As TextBox, _
            ByRef sDrawingDrawNKDatum As TextBox, _
            ByRef sDrawingDrawNKName As TextBox, _
            ByRef sDrawingCADWerkstoff As TextBox, _
            ByRef sDrawingCADMassStab As TextBox, _
            ByRef sDrawingCADZusatzMassStab As TextBox, _
            Optional ByRef SEDraftDatei As SolidEdgeDraft.DraftDocument = Nothing) As Boolean
    Dim lErgebnis As Boolean
    Dim PropSets As SolidEdgeFramework.PropertySets
    Dim Properties As SolidEdgeFramework.Properties
    lErgebnis = False
    
    On Error Resume Next
        Err.Clear
        If SEDraftDatei Is Nothing Then
            Set SEDraftDatei = objSeApp.ActiveDocument
        End If
        With seEigenschaften
            sDrawingDrawDescription.Text = .lieferePropertie(SEDraftDatei, "Custom", "DRAWING-DRAW-DESCRIPTION")
            sDrawingDrawDocumentType.Text = .lieferePropertie(SEDraftDatei, "Custom", "DRAWING-DRAW-DOCUMENTTYPE")
            sDrawingDrawDocumentNumber.Text = .lieferePropertie(SEDraftDatei, "Custom", "DRAWING-DRAW-DOCUMENTNUMBER")
            sDrawingDrawDocumentPart.Text = .lieferePropertie(SEDraftDatei, "Custom", "DRAWING-DRAW-DOCUMENTPART")
            sDrawingDrawDocumentVersion.Text = .lieferePropertie(SEDraftDatei, "Custom", "DRAWING-DRAW-DOCUMENTVERSION")
            sDrawingDrawECNumber.Text = .lieferePropertie(SEDraftDatei, "Custom", "DRAWING-DRAW-ECNUMBER")
            sDrawingMaraMatNr.Text = .lieferePropertie(SEDraftDatei, "Custom", "DRAWING-MARA-MATNR")
            sDrawingDrawPADatum.Text = lieferePropertieAlternativ(SEDraftDatei, "Custom", "DRAWING-PA-DATUM", "MR-DRAWING-PA-DATUM")
            sDrawingDrawPAName.Text = lieferePropertieAlternativ(SEDraftDatei, "Custom", "DRAWING-PA-NAME", "MR-DRAWING-PA-NAME")
            sDrawingDrawK1Datum.Text = lieferePropertieAlternativ(SEDraftDatei, "Custom", "DRAWING-K1-DATUM", "MR-DRAWING-K1-DATUM")
            sDrawingDrawK1Name.Text = lieferePropertieAlternativ(SEDraftDatei, "Custom", "DRAWING-K1-NAME", "MR-DRAWING-K1-NAME")
            sDrawingDrawNKDatum.Text = lieferePropertieAlternativ(SEDraftDatei, "Custom", "DRAWING-NK-DATUM", "MR-DRAWING-NK-DATUM")
            sDrawingDrawNKName.Text = lieferePropertieAlternativ(SEDraftDatei, "Custom", "DRAWING-NK-NAME", "MR-DRAWING-NK-NAME")
            sDrawingCADWerkstoff.Text = .lieferePropertie(SEDraftDatei, "Custom", "DRAWING-CAD_WERKSTOFF")
            sDrawingCADMassStab.Text = .lieferePropertie(SEDraftDatei, "Custom", "DRAWING-CAD_MASSSTAB")
            sDrawingCADZusatzMassStab.Text = .lieferePropertie(SEDraftDatei, "Custom", "DRAWING-CAD_ZUSATZMASSSTAB")
        End With
    On Error GoTo 0
    leseGedasSchriftfeldProperties = lErgebnis
End Function

Private Function lieferePropertieAlternativ(ByRef SeDokument As Object, _
            ByVal sPropertySet As String, ByVal sProptery As String, ByVal sAlternativProptery As String) As String
    Dim sWert As String
    With seEigenschaften
        sWert = .lieferePropertie(SeDokument, sPropertySet, sProptery)
        If (sWert = "") Or (sWert = "-") Then
            sWert = .lieferePropertie(SeDokument, sPropertySet, sAlternativProptery)
        End If
    End With
    lieferePropertieAlternativ = sWert
End Function

Public Function anlegenGedasSchriftfeldProperties(Optional sDrawingDrawDescription As String = "-", _
            Optional sDrawingDrawDocumentType As String = "-", _
            Optional sDrawingDrawDocumentNumber As String = "-", _
            Optional sDrawingDrawDocumentPart As String = "-", _
            Optional sDrawingDrawDocumentVersion As String = "-", _
            Optional sDrawingDrawECNumber As String = "-", _
            Optional sDrawingMaraMatNr As String = "-", _
            Optional sDrawingDrawPADatum As String = "-", _
            Optional sDrawingDrawPAName As String = "-", _
            Optional sDrawingDrawK1Datum As String = "-", _
            Optional sDrawingDrawK1Name As String = "-", _
            Optional sDrawingDrawNKDatum As String = "-", _
            Optional sDrawingDrawNKName As String = "-", _
            Optional sDrawingCADWerkstoff As String = "-", _
            Optional sDrawingCADMassStab As String = "-", _
            Optional sDrawingCADZusatzMassStab As String = "-", _
            Optional SEDraftDatei As SolidEdgeDraft.DraftDocument = Nothing) As Boolean
    Dim lErgebnis As Boolean
    Dim PropSets As SolidEdgeFramework.PropertySets
    Dim Properties As SolidEdgeFramework.Properties
    lErgebnis = False
    
    On Error Resume Next
        Err.Clear
        If SEDraftDatei Is Nothing Then
            Set SEDraftDatei = objSeApp.ActiveDocument
        End If
        Set PropSets = SEDraftDatei.Properties
        Set Properties = PropSets("Custom")                             ' richtige Eigenschaftenseite ffnen
        If (Err.Number = 0) Then                                        ' wenn bis jetzt kein Fehler
            With Properties
                .Add "DRAWING-DRAW-DESCRIPTION", sDrawingDrawDescription
                .Add "DRAWING-DRAW-DOCUMENTTYPE", sDrawingDrawDocumentType
                .Add "DRAWING-DRAW-DOCUMENTNUMBER", sDrawingDrawDocumentNumber
                .Add "DRAWING-DRAW-DOCUMENTPART", sDrawingDrawDocumentPart
                .Add "DRAWING-DRAW-DOCUMENTVERSION", sDrawingDrawDocumentVersion
                .Add "DRAWING-DRAW-ECNUMBER", sDrawingDrawECNumber
                .Add "DRAWING-MARA-MATNR", sDrawingMaraMatNr
                .Add "DRAWING-PA-DATUM", sDrawingDrawPADatum
                .Add "DRAWING-PA-NAME", sDrawingDrawPAName
                .Add "DRAWING-K1-DATUM", sDrawingDrawK1Datum
                .Add "DRAWING-K1-NAME", sDrawingDrawK1Name
                .Add "DRAWING-NK-DATUM", sDrawingDrawNKDatum
                .Add "DRAWING-NK-NAME", sDrawingDrawNKName
                .Add "DRAWING-CAD_WERKSTOFF", sDrawingCADWerkstoff
                .Add "DRAWING-CAD_MASSSTAB", sDrawingCADMassStab
                .Add "DRAWING-CAD_ZUSATZMASSSTAB", sDrawingCADZusatzMassStab
                .Save
            End With
            If (Err.Number = 0) Then
                lErgebnis = True
            Else
                Err.Clear
                lErgebnis = False
            End If
        End If
    '
    anlegenGedasSchriftfeldProperties = lErgebnis
End Function

'---------------------------------------------------------------------------------------
' Procedure : allesAuswaehlbar
' DateTime  : 16.12.2002 08:21
' Author    : Niesner
' Purpose   : Setzt die Eigenschaft Locatable aller Gruppen der Gruppenauflistung SEGruppen
'             auf true. Wenn kein Fehler aufgetreten ist wird die Anzahl der umgestellten
'             Gruppen zurckgegeben. Bei einem Fehler wird -1 zurckgegeben
'---------------------------------------------------------------------------------------
'
Private Function allesAuswaehlbar(ByRef SEGruppen As SolidEdgeFrameworkSupport.Groups) As Long
    Dim SEGruppe As SolidEdgeFrameworkSupport.Group
    Dim lZaehler As Long
    lZaehler = 0
    On Error Resume Next
        Err.Clear
        For Each SEGruppe In SEGruppen
            If SEGruppe.Locatable = False Then
                SEGruppe.Locatable = True
                lZaehler = lZaehler + 1
            End If
        Next
        If Err Then
            allesAuswaehlbar = -1
        Else
            allesAuswaehlbar = lZaehler
        End If
    On Error GoTo 0
    Set SEGruppe = Nothing
End Function

Private Sub setMsg(pAutoRun As Boolean)
    If pAutoRun Then
        Call logWrite(sFehler)
    Else
        MsgBox sFehler, vbInformation
    End If
End Sub

